# ASTER main board software

This directory contains the software for the main board controlling the ASTER hardware.

## Development

### Hardware setup
To be able to flash code to the STM, a Nucleo-F722ZE is used as a programming board.
The process is described in
Section 6.3.4 *Using ST-LINK/V2-1 to program and debug an external STM32 application*
in the [Nucleo documentation](../documentation/datasheets/Nucleo.pdf).
* The `CN4` jumpers have to be removed
* and `CN6` has to be connected to the main board as shown in the following table:

| Nucleo Connection                                                                                                                                         | Main PCB connection                                                                              |
|-----------------------------------------------------------------------------------------------------------------------------------------------------------|--------------------------------------------------------------------------------------------------|
| ![A map of the Nucleo](../documentation/images/NucleoMap.PNG) ![The coble configuration on the Nucleo](../documentation/images/FlashConnectionNucleo.jpg) | ![The coble configuration on the main board](../documentation/images/FlashConnectionMainPCB.jpg) |

### Coding style
[Clang Format](https://clang.llvm.org/docs/ClangFormat.html) is used to format the code. For
STM32CubeIDE, the [CppStyle](https://github.com/wangzw/CppStyle) can be used to integrate Clang
Format.
Don't format code files with autogenerated code, to avoid generating a huge change everytime
the CubeMx project is regenerated. If possible, only format the code in the sections of the
file which don't get overwritten by Cube Mx.

### Generating or updating generated code
#### STM project
[This folder](.) is a STM32Cube project, which means the low level code including drivers
and hardware configuration can be edited and regenerated by opening
[`ASTER_STM_Software.ioc`](ASTER_STM_Software.ioc) in
[STM32CubeMX](https://www.st.com/en/development-tools/stm32cubemx.html). This allows to update to
new driver versions, change the hardware configuration, including the CPU and attached peripherals
by making the changes in Cube Mx and then pressing the `Generate Project` button.

#### Communication serializer and parser
The code in [`Core/Inc/generated`](Core/Inc/generated) and
[`Core/Src/generated`](Core/Src/generated) is generated based
on the current definition of the communication in the [Communication Database](../communication).

If any changes to the communication protocol are made in the
[Communication Database](../communication), the communication code has to be updated with
[this Python script](../communication/ECom/scripts/ecomUpdate.py). It will generate header files in
[generated header folder](Core/Inc/generated) and source files in
[generated source folder](Core/Src/generated). Any changes in these files will be overwritten the
next time the script is run. It is not necessary to run the script every time during build, only
after changing the [Communication database](../communication).
Read [here](../communication/ECom/README.md#code-generation) for more information on the script.
To update the generated code, run the following line in the [top level of the repository](..):
(On Windows, use `set` instead of `export` and replace path separators.)
```shell
python communication/ECom/scripts/ecomUpdate.py --database communication ASTER_STM_Software/Core/Src ASTER_STM_Software/Core/Inc
```

Alternatively, if the ECom library is [installed](../communication/ECom/README.md#installation),
the command simplifies to just:
```shell
ecomUpdate --database communication ASTER_STM_Software/Core/Src ASTER_STM_Software/Core/Inc
```
